/*
 * AlgorithmAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _ALGORITHM_ABSTRACTION_HPP_
#define _ALGORITHM_ABSTRACTION_HPP_

#include <alib/memory>

#include <abstraction/NaryOperationAbstraction.hpp>

#include <registry/Registry.h>

namespace abstraction {

template < class ReturnType, class ... ParamTypes >
class AlgorithmAbstraction : public NaryOperationAbstraction < ReturnType, ParamTypes ... > {
	std::function < ReturnType ( ParamTypes ... ) > m_callback;

public:
	AlgorithmAbstraction ( std::function < ReturnType ( ParamTypes ... ) > callback ) : m_callback ( callback ) {
	}

	virtual bool run ( ) override {
		this->template run_helper < ParamTypes ... > ( m_callback, this->m_params );
		return true;
	}

};

} /* namespace abstraction */

#endif /* _ALGORITHM_ABSTRACTION_HPP_ */
