/*
 * CastAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _CAST_ABSTRACTION_HPP_
#define _CAST_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>

namespace abstraction {

template < class ReturnType, class ParamType >
class CastAbstraction : public UnaryOperationAbstraction < ReturnType, const ParamType & > {
public:
	virtual bool run ( ) override {
		std::pair < std::shared_ptr < OperationAbstraction >, bool > & param = std::get < 0 > ( this->m_params );
		this->m_data = ReturnType ( retrieveValue < const ParamType & > ( param.first, param.second ) );

		return true;
	}
};

} /* namespace abstraction */

#endif /* _CAST_ABSTRACTION_HPP_ */
