/*
 * Translate.cpp
 *
 *  Created on: 12. 5. 2016
 *      Author: Jakub Doupal
 */

#include "Translate.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace run {

auto TranslateNPDTALinearString = registration::AbstractRegister < Translate, ext::set < string::LinearString < > >, const automaton::NPDTA < > &, const string::LinearString < > & > ( Translate::translate, "automaton", "string" ).setDocumentation (
"Implementation of a run of an automaton that is producing output.\n\
\n\
@param automaton the runned automaton\n\
@param string the input of the automaton\n\
@return set of strings representing the translations" );

} /* namespace run */

} /* namespace automaton */
