/*
 * UselessStatesRemover.cpp
 *
 *  Created on: 23. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "UselessStatesRemover.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace simplify {

auto UselessStatesRemoverEpsilonNFA = registration::AbstractRegister < UselessStatesRemover, automaton::EpsilonNFA < >, const automaton::EpsilonNFA < > & > ( UselessStatesRemover::remove, "automaton" ).setDocumentation (
"Removes useless states from an automaton.\n\
\n\
@param automaton automaton to trim\n\
@return @p automaton without useless states" );

auto UselessStatesRemoverNFA = registration::AbstractRegister < UselessStatesRemover, automaton::NFA < >, const automaton::NFA < > & > ( UselessStatesRemover::remove, "automaton" ).setDocumentation (
"Removes useless states from an automaton.\n\
\n\
@param automaton automaton to trim\n\
@return @p automaton without useless states" );

auto UselessStatesRemoverCompactNFA = registration::AbstractRegister < UselessStatesRemover, automaton::CompactNFA < >, const automaton::CompactNFA < > & > ( UselessStatesRemover::remove, "automaton" ).setDocumentation (
"Removes useless states from an automaton.\n\
\n\
@param automaton automaton to trim\n\
@return @p automaton without useless states" );

auto UselessStatesRemoverExtendedNFA = registration::AbstractRegister < UselessStatesRemover, automaton::ExtendedNFA < >, const automaton::ExtendedNFA < > & > ( UselessStatesRemover::remove, "automaton" ).setDocumentation (
"Removes useless states from an automaton.\n\
\n\
@param automaton automaton to trim\n\
@return @p automaton without useless states" );

auto UselessStatesRemoverDFA = registration::AbstractRegister < UselessStatesRemover, automaton::DFA < >, const automaton::DFA < > & > ( UselessStatesRemover::remove, "automaton" ).setDocumentation (
"Removes useless states from an automaton.\n\
\n\
@param automaton automaton to trim\n\
@return @p automaton without useless states" );

auto UselessStatesRemoverMultiInitialStateNFA = registration::AbstractRegister < UselessStatesRemover, automaton::MultiInitialStateNFA < >, const automaton::MultiInitialStateNFA < > & > ( UselessStatesRemover::remove, "automaton" ).setDocumentation (
"Removes useless states from an automaton.\n\
\n\
@param automaton automaton to trim\n\
@return @p automaton without useless states" );

auto UselessStatesRemoverDFTA = registration::AbstractRegister < UselessStatesRemover, automaton::DFTA < >, const automaton::DFTA < > & > ( UselessStatesRemover::remove, "dfta" ).setDocumentation (
"Removes unreachable states from a deterministic finite tree automaton.\n\
\n\
@param dfta automaton to trim\n\
@return @p autoamton without unreachable states" );

} /* namespace simplify */

} /* namespace automaton */
