/*
 * ToGrammarRightRG.cpp
 *
 *  Created on: 8. 3. 2014
 *      Author: Tomas Pecka
 */

#include "ToGrammarRightRG.h"
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace convert {

auto ToGrammarRightRGLeftRG = registration::AbstractRegister < ToGrammarRightRG, grammar::RightRG < >, const grammar::LeftRG < > & > ( ToGrammarRightRG::convert, "grammar" ).setDocumentation (
"Transforms a left regular grammar to right regular grammar.\n\
\n\
@param grammar the left regular grammar to convert\n\
@return right regular grammar which is equivalent to source left regular grammar." );

} /* namespace convert */

} /* namespace grammar */
