/*
 * ToRegExpAlgebraic.cpp
 *
 *  Created on: 4. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "ToRegExpAlgebraic.h"
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace convert {

auto ToRegExpAlgebraicLeftRG = registration::AbstractRegister < ToRegExpAlgebraic, regexp::UnboundedRegExp < >, const grammar::LeftRG < > & > ( ToRegExpAlgebraic::convert, "grammar" ).setDocumentation (
"Converts a regular grammar to regular expression using regular equations.\n\
\n\
@param grammar Grammar to convert\n\
@return regexp describing language generated by the @p grammar" );

auto ToRegExpAlgebraicRightRG = registration::AbstractRegister < ToRegExpAlgebraic, regexp::UnboundedRegExp < >, const grammar::RightRG < > & > ( ToRegExpAlgebraic::convert, "grammar" ).setDocumentation (
"Converts a regular grammar to regular expression using regular equations.\n\
\n\
@param grammar Grammar to convert\n\
@return regexp describing language generated by the @p grammar" );

} /* namespace convert */

} /* namespace grammar */
