/*
 * CockeYoungerKasami.cpp
 *
 *  Created on: 22. 3. 2014
 *	  Author: Jan Travnicek
 */

#include "CockeYoungerKasami.h"
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace generate {

auto CockeYoungerKasamiCNF = registration::AbstractRegister < CockeYoungerKasami, bool, const grammar::CNF < > &, const string::LinearString < > & > ( CockeYoungerKasami::generate, "grammar", "string" ).setDocumentation (
"Implements the Cocke Younger Kasami algorithm to test whether string is in language generated by a grammar\n\
\n\
@param grammar context free grammar in chomsky's normal form.\n\
@param string the tested string\n\
@return true if the @p grammar generates a language containing @p string" );

} /* namespace generate */

} /* namespace grammar */
