/*
 * CockeYoungerKasamiVerbose.cpp
 *
 *  Created on: 22. 3. 2014
 *	  Author: Jan Travnicek
 */

#include "CockeYoungerKasamiVerbose.h"
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace generate {

auto CockeYoungerKasamiVerboseCNF = registration::AbstractRegister < CockeYoungerKasamiVerbose, ext::vector < ext::vector < ext::set < DefaultSymbolType > > >, const grammar::CNF < > &, const string::LinearString < > & > ( CockeYoungerKasamiVerbose::generate, "grammar", "string" ).setDocumentation (
"Implements the Cocke Younger Kasami algorithm to test whether string is in language generated by a grammar.\n\
\n\
@param grammar context free grammar in chomsky's normal form\n\
@param string the tested string\n\
@return the internal table constructed by the Cock Younger Kasami algorithm" );

} /* namespace generate */

} /* namespace grammar */
