/*
 * ToCNF.cpp
 *
 *  Created on: 24. 11. 2014
 *	  Author: Jan Travnicek
 */

#include "ToCNF.h"
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace simplify {

auto ToCNFCFG = registration::AbstractRegister < ToCNF, grammar::CNF < DefaultSymbolType, ext::vector < ext::variant < DefaultSymbolType, DefaultSymbolType > > >, const grammar::CFG < > & > ( ToCNF::convert, "grammar" ).setDocumentation (
"Implements transformation of a grammar into chomsky's normal form.\n\
\n\
@param grammar the transformed grammar\n\
@return an grammar in chomsky's normal form equivalent to the @p grammar" );

auto ToCNFEpsilonFreeCFG = registration::AbstractRegister < ToCNF, grammar::CNF < DefaultSymbolType, ext::vector < ext::variant < DefaultSymbolType, DefaultSymbolType > > >, const grammar::EpsilonFreeCFG < > & > ( ToCNF::convert, "grammar" ).setDocumentation (
"Implements transformation of a grammar into chomsky's normal form.\n\
\n\
@param grammar the transformed grammar\n\
@return an grammar in chomsky's normal form equivalent to the @p grammar" );

auto ToCNFCNF = registration::AbstractRegister < ToCNF, grammar::CNF < >, const grammar::CNF < > & > ( ToCNF::convert, "grammar" ).setDocumentation (
"Implements transformation of a grammar into chomsky's normal form.\n\
\n\
@param grammar the transformed grammar\n\
@return an grammar in chomsky's normal form equivalent to the @p grammar" );

auto ToCNFGNF = registration::AbstractRegister < ToCNF, grammar::CNF < DefaultSymbolType, ext::vector < ext::variant < DefaultSymbolType, DefaultSymbolType > > >, const grammar::GNF < > & > ( ToCNF::convert, "grammar" ).setDocumentation (
"Implements transformation of a grammar into chomsky's normal form.\n\
\n\
@param grammar the transformed grammar\n\
@return an grammar in chomsky's normal form equivalent to the @p grammar" );

auto ToCNFLG = registration::AbstractRegister < ToCNF, grammar::CNF < DefaultSymbolType, ext::vector < ext::variant < DefaultSymbolType, DefaultSymbolType > > >, const grammar::LG < > & > ( ToCNF::convert, "grammar" ).setDocumentation (
"Implements transformation of a grammar into chomsky's normal form.\n\
\n\
@param grammar the transformed grammar\n\
@return an grammar in chomsky's normal form equivalent to the @p grammar" );

auto ToCNFLeftLG = registration::AbstractRegister < ToCNF, grammar::CNF < DefaultSymbolType, ext::vector < ext::variant < DefaultSymbolType, DefaultSymbolType > > >, const grammar::LeftLG < > & > ( ToCNF::convert, "grammar" ).setDocumentation (
"Implements transformation of a grammar into chomsky's normal form.\n\
\n\
@param grammar the transformed grammar\n\
@return an grammar in chomsky's normal form equivalent to the @p grammar" );

auto ToCNFLeftRG = registration::AbstractRegister < ToCNF, grammar::CNF < DefaultSymbolType, ext::variant < DefaultSymbolType, DefaultSymbolType > >, const grammar::LeftRG < > & > ( ToCNF::convert, "grammar" ).setDocumentation (
"Implements transformation of a grammar into chomsky's normal form.\n\
\n\
@param grammar the transformed grammar\n\
@return an grammar in chomsky's normal form equivalent to the @p grammar" );

auto ToCNFRightLG = registration::AbstractRegister < ToCNF, grammar::CNF < DefaultSymbolType, ext::vector < ext::variant < DefaultSymbolType, DefaultSymbolType > > >, const grammar::RightLG < > & > ( ToCNF::convert, "grammar" ).setDocumentation (
"Implements transformation of a grammar into chomsky's normal form.\n\
\n\
@param grammar the transformed grammar\n\
@return an grammar in chomsky's normal form equivalent to the @p grammar" );

auto ToCNFRightRG = registration::AbstractRegister < ToCNF, grammar::CNF < DefaultSymbolType, ext::variant < DefaultSymbolType, DefaultSymbolType > >, const grammar::RightRG < > & > ( ToCNF::convert, "grammar" ).setDocumentation (
"Implements transformation of a grammar into chomsky's normal form.\n\
\n\
@param grammar the transformed grammar\n\
@return an grammar in chomsky's normal form equivalent to the @p grammar" );

} /* namespace simplify */

} /* namespace grammar */
