/*
 * UnproductiveSymbolsRemover.cpp
 *
 *  Created on: 22. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "UnproductiveSymbolsRemover.h"
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace simplify {

auto UnproductiveSymbolsRemoverCFG = registration::AbstractRegister < UnproductiveSymbolsRemover, grammar::CFG < >, const grammar::CFG < > & > ( UnproductiveSymbolsRemover::remove, "grammar" ).setDocumentation (
"Removes unproductive symbols.\n\
\n\
@param grammar the modified grammar\n\
@return grammar equivalent to @p grammar without unproductive symbols" );

auto UnproductiveSymbolsRemoverEpsilonFreeCFG = registration::AbstractRegister < UnproductiveSymbolsRemover, grammar::EpsilonFreeCFG < >, const grammar::EpsilonFreeCFG < > & > ( UnproductiveSymbolsRemover::remove, "grammar" ).setDocumentation (
"Removes unproductive symbols.\n\
\n\
@param grammar the modified grammar\n\
@return grammar equivalent to @p grammar without unproductive symbols" );

auto UnproductiveSymbolsRemoverGNF = registration::AbstractRegister < UnproductiveSymbolsRemover, grammar::GNF < >, const grammar::GNF < > & > ( UnproductiveSymbolsRemover::remove, "grammar" ).setDocumentation (
"Removes unproductive symbols.\n\
\n\
@param grammar the modified grammar\n\
@return grammar equivalent to @p grammar without unproductive symbols" );

auto UnproductiveSymbolsRemoverCNF = registration::AbstractRegister < UnproductiveSymbolsRemover, grammar::CNF < >, const grammar::CNF < > & > ( UnproductiveSymbolsRemover::remove, "grammar" ).setDocumentation (
"Removes unproductive symbols.\n\
\n\
@param grammar the modified grammar\n\
@return grammar equivalent to @p grammar without unproductive symbols" );

auto UnproductiveSymbolsRemoverLG = registration::AbstractRegister < UnproductiveSymbolsRemover, grammar::LG < >, const grammar::LG < > & > ( UnproductiveSymbolsRemover::remove, "grammar" ).setDocumentation (
"Removes unproductive symbols.\n\
\n\
@param grammar the modified grammar\n\
@return grammar equivalent to @p grammar without unproductive symbols" );

auto UnproductiveSymbolsRemoverLeftLG = registration::AbstractRegister < UnproductiveSymbolsRemover, grammar::LeftLG < >, const grammar::LeftLG < > & > ( UnproductiveSymbolsRemover::remove, "grammar" ).setDocumentation (
"Removes unproductive symbols.\n\
\n\
@param grammar the modified grammar\n\
@return grammar equivalent to @p grammar without unproductive symbols" );

auto UnproductiveSymbolsRemoverLeftRG = registration::AbstractRegister < UnproductiveSymbolsRemover, grammar::LeftRG < >, const grammar::LeftRG < > & > ( UnproductiveSymbolsRemover::remove, "grammar" ).setDocumentation (
"Removes unproductive symbols.\n\
\n\
@param grammar the modified grammar\n\
@return grammar equivalent to @p grammar without unproductive symbols" );

auto UnproductiveSymbolsRemoverRightLG = registration::AbstractRegister < UnproductiveSymbolsRemover, grammar::RightLG < >, const grammar::RightLG < > & > ( UnproductiveSymbolsRemover::remove, "grammar" ).setDocumentation (
"Removes unproductive symbols.\n\
\n\
@param grammar the modified grammar\n\
@return grammar equivalent to @p grammar without unproductive symbols" );

auto UnproductiveSymbolsRemoverRightRG = registration::AbstractRegister < UnproductiveSymbolsRemover, grammar::RightRG < >, const grammar::RightRG < > & > ( UnproductiveSymbolsRemover::remove, "grammar" ).setDocumentation (
"Removes unproductive symbols.\n\
\n\
@param grammar the modified grammar\n\
@return grammar equivalent to @p grammar without unproductive symbols" );

} /* namespace simplify */

} /* namespace grammar */

