/*
 * RegExpOptimize.cpp
 *
 *  Created on: 20. 1. 2014
 *	  Author: Tomas Pecka
 */

#include "RegExpOptimize.h"
#include <registration/AlgoRegistration.hpp>

namespace regexp {

namespace simplify {

auto RegExpOptimizeFormalRegExp = registration::AbstractRegister < RegExpOptimize, FormalRegExp < >, const FormalRegExp < > & > ( RegExpOptimize::optimize, "regexp" ).setDocumentation (
"Implements a regexp simplification algorithm that is transforming the regular expression to be smaller.\n\
\n\
@param regexp the simplified regexp\n\
@return the simlified regexp" );

auto RegExpOptimizeUnboundedRegExp = registration::AbstractRegister < RegExpOptimize, UnboundedRegExp < >, const UnboundedRegExp < > & > ( RegExpOptimize::optimize, "regexp" ).setDocumentation (
"Implements a regexp simplification algorithm that is transforming the regular expression to be smaller.\n\
\n\
@param regexp the simplified regexp\n\
@return the simlified regexp" );

} /* namespace regexp */

} /* namespace simplify */
