/*
 * RegExpConcatenate.cpp
 *
 *  Created on: 17. 10. 2014
 *	  Author: Jan Travnicek
 */

#include "RegExpConcatenate.h"
#include <registration/AlgoRegistration.hpp>

namespace regexp {

auto RegExpConcatenateFormalRegExp = registration::AbstractRegister < RegExpConcatenate, regexp::FormalRegExp < >, const regexp::FormalRegExp < > &, const regexp::FormalRegExp < > & > ( RegExpConcatenate::concatenate, "first", "second" ).setDocumentation (
"Implements concatenation of two regular expressions.\n\
\n\
@param first the first regexp to concatenate\n\
@param second the second regexp to concatenate\n\
@return regexp describing first . second" );

auto RegExpConcatenateUnboundedRegExp = registration::AbstractRegister < RegExpConcatenate, regexp::UnboundedRegExp < >, const regexp::UnboundedRegExp < > &, const regexp::UnboundedRegExp < > & > ( RegExpConcatenate::concatenate, "first", "second" ).setDocumentation (
"Implements concatenation of two regular expressions.\n\
\n\
@param first the first regexp to concatenate\n\
@param second the second regexp to concatenate\n\
@return regexp describing first . second" );

} /* namespace regexp */
