/*
 * HammingMatchingAutomaton.cpp
 *
 *  Created on: 12. 3. 2018
 *      Author: Tomas Capek
 */

#include "HammingMatchingAutomaton.h"
#include <registration/AlgoRegistration.hpp>

namespace stringology {

namespace matching {

auto HammingMatchingAutomatonLinearString = registration::AbstractRegister <HammingMatchingAutomaton, automaton::NFA < DefaultSymbolType, ext::pair<unsigned int, unsigned int> >, const string::LinearString < > &, unsigned > ( HammingMatchingAutomaton::construct );

auto HammingMatchingAutomatonWildcardLinearString = registration::AbstractRegister <HammingMatchingAutomaton, automaton::NFA < DefaultSymbolType, ext::pair<unsigned int, unsigned int> >, const string::WildcardLinearString < > &, unsigned > ( HammingMatchingAutomaton::construct );


} /* namespace matching */

} /* namespace stringology */
