/*
 * GrammarCompare.cpp
 *
 *  Created on: Apr 1, 2013
 *      Author: honza
 */

#include "GrammarCompare.h"
#include <registration/AlgoRegistration.hpp>

namespace compare {

auto GrammarCompareLeftLG = registration::AbstractRegister < GrammarCompare, bool, const grammar::LeftLG < > &, const grammar::LeftLG < > & > ( GrammarCompare::compare );
auto GrammarCompareLeftRG = registration::AbstractRegister < GrammarCompare, bool, const grammar::LeftRG < > &, const grammar::LeftRG < > & > ( GrammarCompare::compare );
auto GrammarCompareRightLG = registration::AbstractRegister < GrammarCompare, bool, const grammar::RightLG < > &, const grammar::RightLG < > & > ( GrammarCompare::compare );
auto GrammarCompareRightRG = registration::AbstractRegister < GrammarCompare, bool, const grammar::RightRG < > &, const grammar::RightRG < > & > ( GrammarCompare::compare );

auto GrammarCompareLG = registration::AbstractRegister < GrammarCompare, bool, const grammar::LG < > &, const grammar::LG < > & > ( GrammarCompare::compare );
auto GrammarCompareCFG = registration::AbstractRegister < GrammarCompare, bool, const grammar::CFG < > &, const grammar::CFG < > & > ( GrammarCompare::compare );
auto GrammarCompareEpsilonFreeCFG = registration::AbstractRegister < GrammarCompare, bool, const grammar::EpsilonFreeCFG < > &, const grammar::EpsilonFreeCFG < > & > ( GrammarCompare::compare );
auto GrammarCompareCNF = registration::AbstractRegister < GrammarCompare, bool, const grammar::CNF < > &, const grammar::CNF < > & > ( GrammarCompare::compare );
auto GrammarCompareGNF = registration::AbstractRegister < GrammarCompare, bool, const grammar::GNF < > &, const grammar::GNF < > & > ( GrammarCompare::compare );
auto GrammarCompareCSG = registration::AbstractRegister < GrammarCompare, bool, const grammar::CSG < > &, const grammar::CSG < > & > ( GrammarCompare::compare );

auto GrammarCompareNonContractingGrammar = registration::AbstractRegister < GrammarCompare, bool, const grammar::NonContractingGrammar < > &, const grammar::NonContractingGrammar < > & > ( GrammarCompare::compare );
auto GrammarCompareContextPreservingUnrestrictedGrammar = registration::AbstractRegister < GrammarCompare, bool, const grammar::ContextPreservingUnrestrictedGrammar < > &, const grammar::ContextPreservingUnrestrictedGrammar < > & > ( GrammarCompare::compare );

auto GrammarCompareUnrestrictedGrammar = registration::AbstractRegister < GrammarCompare, bool, const grammar::UnrestrictedGrammar < > &, const grammar::UnrestrictedGrammar < > & > ( GrammarCompare::compare );

} /* namespace compare */
