/*
 * GrammarDiff.cpp
 *
 *  Created on: Apr 1, 2013
 *      Author: honza
 */

#include "GrammarDiff.h"
#include <registration/AlgoRegistration.hpp>

namespace compare {

auto GrammarDiffLeftLG = registration::AbstractRegister < GrammarDiff, std::string, const grammar::LeftLG < > &, const grammar::LeftLG < > & > ( GrammarDiff::diff );
auto GrammarDiffLeftRG = registration::AbstractRegister < GrammarDiff, std::string, const grammar::LeftRG < > &, const grammar::LeftRG < > & > ( GrammarDiff::diff );
auto GrammarDiffRightLG = registration::AbstractRegister < GrammarDiff, std::string, const grammar::RightLG < > &, const grammar::RightLG < > & > ( GrammarDiff::diff );
auto GrammarDiffRightRG = registration::AbstractRegister < GrammarDiff, std::string, const grammar::RightRG < > &, const grammar::RightRG < > & > ( GrammarDiff::diff );

auto GrammarDiffLG = registration::AbstractRegister < GrammarDiff, std::string, const grammar::LG < > &, const grammar::LG < > & > ( GrammarDiff::diff );
auto GrammarDiffCFG = registration::AbstractRegister < GrammarDiff, std::string, const grammar::CFG < > &, const grammar::CFG < > & > ( GrammarDiff::diff );
auto GrammarDiffEpsilonFreeCFG = registration::AbstractRegister < GrammarDiff, std::string, const grammar::EpsilonFreeCFG < > &, const grammar::EpsilonFreeCFG < > & > ( GrammarDiff::diff );
auto GrammarDiffCNF = registration::AbstractRegister < GrammarDiff, std::string, const grammar::CNF < > &, const grammar::CNF < > & > ( GrammarDiff::diff );
auto GrammarDiffGNF = registration::AbstractRegister < GrammarDiff, std::string, const grammar::GNF < > &, const grammar::GNF < > & > ( GrammarDiff::diff );
auto GrammarDiffCSG = registration::AbstractRegister < GrammarDiff, std::string, const grammar::CSG < > &, const grammar::CSG < > & > ( GrammarDiff::diff );

auto GrammarDiffNonContractingGrammar = registration::AbstractRegister < GrammarDiff, std::string, const grammar::NonContractingGrammar < > &, const grammar::NonContractingGrammar < > & > ( GrammarDiff::diff );
auto GrammarDiffContextPreservingUnrestrictedGrammar = registration::AbstractRegister < GrammarDiff, std::string, const grammar::ContextPreservingUnrestrictedGrammar < > &, const grammar::ContextPreservingUnrestrictedGrammar < > & > ( GrammarDiff::diff );

auto GrammarDiffUnrestrictedGrammar = registration::AbstractRegister < GrammarDiff, std::string, const grammar::UnrestrictedGrammar < > &, const grammar::UnrestrictedGrammar < > & > ( GrammarDiff::diff );

} /* namespace compare */
