/*
 * Dot.h
 *
 *  Created on: 16. 8. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _DOT_H_
#define _DOT_H_

#include <alib/string>
#include <alib/vector>

namespace cli {

namespace builtin {

/**
 * Dot visualisation executioner.
 *
 */
class Dot {
public:
	/**
	 * Cli builtin command for DOT format visualization
	 *
	 * \param dot a string containing dot data
	 */
	static void dot( const std::string & dot );

	/**
	 * Cli builtin command for DOT format visualization
	 *
	 * \param data a string containing dot data
	 * \param outputType the type of dot created image
	 * \param outputFile the destination file name
	 */
	static void dot ( const std::string & data, const std::string & outputType, const std::string & outputFile );

private:
	static std::vector < std::string > m_DotAllowedTypes;
};

} /* namespace builtin */

} /* namespace cli */

#endif /* _DOT_H_ */
