#include <stdio.h>
#include <execinfo.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>

#include "sigHandler.h"

#include "simpleStacktrace.h"
#include <alib/iostream>
#include <global/GlobalData.h>

namespace ext {

#ifdef DEBUG
	void SigHandler::handler(int signal) {
		switch(signal) {
			case SIGSEGV:
				common::Streams::out << "Segmentation fault" << std::endl;
				break;
			case SIGINT:
				common::Streams::out << "Interrupted" << std::endl;
				break;
			default:
				common::Streams::out << "Unknown signal" << std::endl;
				break;
		}
		common::Streams::out << ext::simpleStacktrace() << std::endl;
		exit(1);
	}
#else
	void SigHandler::handler ( int ) {
	}
#endif

SigHandler::SigHandler() {
	#ifdef DEBUG
		signal(SIGSEGV, SigHandler::handler);
		signal(SIGINT, SigHandler::handler);
	#endif
}

SigHandler SigHandler::HANDLER;

} /* namespace ext */
