#include "ParamQualifiers.hpp"

namespace core {

abstraction::ParamQualifiers::ParamQualifier xmlApi < abstraction::ParamQualifiers::ParamQualifier >::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );

	std::string data = sax::FromXMLParserHelper::popTokenData(input, sax::Token::TokenType::CHARACTER);
	abstraction::ParamQualifiers::ParamQualifier res = abstraction::ParamQualifiers::ParamQualifier::CONST;
	if ( data == "lref" )
		res = abstraction::ParamQualifiers::ParamQualifier::LREF;
	else if ( data == "rref" )
		res = abstraction::ParamQualifiers::ParamQualifier::RREF;
	else if ( data == "const" )
		res = abstraction::ParamQualifiers::ParamQualifier::CONST;
	else
		throw exception::CommonException ( "Invalid param qualifier." );

	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::END_ELEMENT, xmlTagName ( ) );

	return res;
}

bool xmlApi < abstraction::ParamQualifiers::ParamQualifier >::first ( const ext::deque < sax::Token >::const_iterator & input ) {
	return sax::FromXMLParserHelper::isToken(input, sax::Token::TokenType::START_ELEMENT, xmlTagName ( ) );
}

std::string xmlApi < abstraction::ParamQualifiers::ParamQualifier >::xmlTagName ( ) {
	return "ParamQualifier";
}

void xmlApi < abstraction::ParamQualifiers::ParamQualifier >::compose ( ext::deque < sax::Token > & out, abstraction::ParamQualifiers::ParamQualifier paramQualifier ) {
	out.emplace_back ( xmlTagName ( ), sax::Token::TokenType::START_ELEMENT);
	switch ( paramQualifier ) {
	case abstraction::ParamQualifiers::ParamQualifier::CONST:
		out.emplace_back("const", sax::Token::TokenType::CHARACTER);
		break;
	case abstraction::ParamQualifiers::ParamQualifier::LREF:
		out.emplace_back("lref", sax::Token::TokenType::CHARACTER);
		break;
	case abstraction::ParamQualifiers::ParamQualifier::RREF:
		out.emplace_back("rref", sax::Token::TokenType::CHARACTER);
		break;
	}
	out.emplace_back ( xmlTagName ( ), sax::Token::TokenType::END_ELEMENT);
}

} /* namespace core */
